# 环形链表——哈希、链表、双指针

> 发布于：2022-03-05 | 分类：刷题 | 原文：https://www.imbailey.cn/post/leetcode-141-linked-list-cycle-hash-two-pointers

## 题目

> 题目来自：https://leetcode-cn.com/problems/linked-list-cycle/

#### 141. 环形链表

难度简单1376收藏分享切换为英文接收动态反馈

给你一个链表的头节点 `head` ，判断链表中是否有环。

如果链表中有某个节点，可以通过连续跟踪 `next` 指针再次到达，则链表中存在环。 为了表示给定链表中的环，评测系统内部使用整数 `pos` 来表示链表尾连接到链表中的位置（索引从 0 开始）。**注意：`pos` 不作为参数进行传递** 。仅仅是为了标识链表的实际情况。

*如果链表中存在环* ，则返回 `true` 。 否则，返回 `false` 。

 

**示例 1：**

![img](https://myblog-1257298572.cos.ap-shanghai.myqcloud.com/mypic/img/circularlinkedlist.png)

```
输入：head = [3,2,0,-4], pos = 1
输出：true
解释：链表中有一个环，其尾部连接到第二个节点。
```

**示例 2：**

![img](https://myblog-1257298572.cos.ap-shanghai.myqcloud.com/mypic/img/circularlinkedlist_test2.png)

```
输入：head = [1,2], pos = 0
输出：true
解释：链表中有一个环，其尾部连接到第一个节点。
```

**示例 3：**

![img](https://myblog-1257298572.cos.ap-shanghai.myqcloud.com/mypic/img/circularlinkedlist_test3.png)

```
输入：head = [1], pos = -1
输出：false
解释：链表中没有环。
```

 

**提示：**

- 链表中节点的数目范围是 `[0, 104]`
- `-105 <= Node.val <= 105`
- `pos` 为 `-1` 或者链表中的一个 **有效索引** 。



## 题解

虽然上学期学完了数据结构，还拿到了90+的成绩，但我一行代码都没有写过，只会纸上谈兵是不行的。

> 参考作者：LeetCode-Solution
> 链接：https://leetcode-cn.com/problems/linked-list-cycle/solution/huan-xing-lian-biao-by-leetcode-solution/
> 来源：力扣（LeetCode）
> 著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。

### 方法一：哈希表

最容易想到的方法，就是遍历这个链表，如果发现某个节点曾经被遍历过了，那么这就是环形链表。判断某个节点是否被遍历过可以用hashset。

代码：

```c++
class Solution {
public:
    bool hasCycle(ListNode *head) {
        unordered_set<ListNode*> seen;
        while (head != nullptr) {
            if (seen.count(head)) {
                return true;
            }
            seen.insert(head);
            head = head->next;
        }
        return false;
    }
};
```

这个代码我是写不出来的，只能先抄题解。有一点不明白的是，`unordered_set<ListNode*> seen;`这一行为什么`<ListNode>`后要加个`*` ？`*`加在前面表示定义指针，加在后面表示什么呢？知道的可以在评论区给我留言。

因为只遍历一次，时间复杂度：O(N) 。要开辟哈希表，空间复杂度O(N)。

### 方法二：快慢指针

这个方法很巧妙，leetcode给的解释非常易懂，还有演示视频。

> 本方法需要读者对「Floyd 判圈算法」（又称龟兔赛跑算法）有所了解。
>
> 假想「乌龟」和「兔子」在链表上移动，「兔子」跑得快，「乌龟」跑得慢。当「乌龟」和「兔子」从链表上的同一个节点开始移动时，如果该链表中没有环，那么「兔子」将一直处于「乌龟」的前方；如果该链表中有环，那么「兔子」会先于「乌龟」进入环，并且一直在环内移动。等到「乌龟」进入环时，由于「兔子」的速度快，它一定会在某个时刻与乌龟相遇，即套了「乌龟」若干圈。
>
> 我们可以根据上述思路来解决本题。具体地，我们定义两个指针，一快一满。慢指针每次只移动一步，而快指针每次移动两步。初始时，慢指针在位置 head，而快指针在位置 head.next。这样一来，如果在移动的过程中，快指针反过来追上慢指针，就说明该链表为环形链表。否则快指针将到达链表尾部，该链表不为环形链表。
>
> 细节:为什么我们要规定初始时慢指针在位置 head，快指针在位置 head.next，而不是两个指针都在位置 head（即与「乌龟」和「兔子」中的叙述相同）？
>
> 观察下面的代码，我们使用的是 while 循环，循环条件先于循环体。由于循环条件一定是判断快慢指针是否重合，如果我们将两个指针初始都置于 head，那么 while 循环就不会执行。因此，我们可以假想一个在 head 之前的虚拟节点，慢指针从虚拟节点移动一步到达 head，快指针从虚拟节点移动两步到达 head.next，这样我们就可以使用 while 循环了。
>
> 当然，我们也可以使用 do-while 循环。此时，我们就可以把快慢指针的初始值都置为 head。
>
> 
>
> 作者：LeetCode-Solution
> 链接：https://leetcode-cn.com/problems/linked-list-cycle/solution/huan-xing-lian-biao-by-leetcode-solution/
> 来源：力扣（LeetCode）
> 著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。

代码：

```c++
class Solution {
public:
    bool hasCycle(ListNode* head) {
        if (head == nullptr || head->next == nullptr) {
            return false;
        }
        ListNode* slow = head;
        ListNode* fast = head->next;
        while (slow != fast) {
            if (fast == nullptr || fast->next == nullptr) {
                return false;
            }
            slow = slow->next;
            fast = fast->next->next;
        }
        return true;
    }
};
```

其实这个代码有点啰嗦。

时间复杂度：O(N)O(N)，其中 NN 是链表中的节点数。

当链表中不存在环时，快指针将先于慢指针到达链表尾部，链表中每个节点至多被访问两次。

当链表中存在环时，每一轮移动后，快慢指针的距离将减小一。而初始距离为环的长度，因此至多移动 NN 轮。

空间复杂度：O(1)。因为只使用了两个指针的额外空间。



[lostBookBoy]问了一个问题：“为什么慢指针每次只移动一步，而快指针每次移动两步而不是其他步？”

[洛阳令]的回答：“这里的慢1快2还是有些讲究的，要是慢一快三未必可以解。快减慢等于1是一定有解的。可以将环理解为一个整数加法群，只有差为一才一定有解。”



### 其它方法：

看了评论区，各路大神各显神通。有的在遍历的时候把链表节点的值改成`'bjfuvth'`，再遇到就说明有环，这样就不用哈希了。还有跑了很多遍代码发现这题的链表最多有8029个节点，跑完8029个后如果还没结束就说明有环。哈哈哈，为了能过一道题真是无所不用其极。

这是一道很简单的题，做出来可能只需要5分钟，但是在整理这道题时我花了1个小时，学习就是这个样子，不怕折腾。
